/************************************************************************

    JSWED 2.2.9 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001, 2006  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "jswed.hxx"
#include "jswgame.hxx"
#include "jswpatchpage.hxx"
#include "patch.hxx"
#include "filetypelist.hxx"

/* Change all IX+9 to IX+6 */
PatchLine plIX6old[] = 	{
	{ 0x92AA, 9, 6 },
	{ 0x92CE, 9, 6 },
	{ 0x92D8, 9, 6 },
	{ 0x9315, 9, 6 },
	{ 0x9352, 9, 6 },
	{ 0x935A, 9, 6 },
};


/* Change all IX+9 to IX+6, and move the 'Willy on rope?' flag from 
 * IX+0B bit 0 to IX+0 bit 5.  */
PatchLine plIX6new[] = 	{
	{ 0x92AA, 9, 6 },	 // 0
	{ 0x92CE, 9, 6 },	 // 1
	{ 0x92D4, 0x0B, 0x00 },	 // 2 SET 0,(IX+0Bh) -> SET 5,(IX+0)
	{ 0x92D5, 0xC6, 0xEE },	 // 3
	{ 0x92D8, 9, 6 },	 // 4
	{ 0x92DD, 0x0B, 0x00 },	 // 5 BIT 0,(IX+0Bh) -> BIT 5,(IX+0)
	{ 0x92DE, 0x46, 0x6E },	 // 6
	{ 0x9315, 9, 6 },	 // 7
	{ 0x9352, 9, 6 },	 // 8
	{ 0x935A, 9, 6 },	 // 9
	{ 0x936B, 0x0B, 0x00, },	 // RES 0,(IX+0Bh) -> RES 5,(IX+0)
	{ 0x936C, 0x86, 0xAE, },
	{ 0x9371, 0x0B, 0x00, },	 // BIT 0,(IX+0Bh) -> BIT 5,(IX+0)
	{ 0x9372, 0x46, 0x6E, },
};


PatchLine plBlackWilly[] = {
	{ 0x962C, 0xF6, 0xE6}, 
	{ 0x962D, 0x07, 0xF8},
	{ 0x9280, 0x07, 0x00},
	{ 0x93F0, 0x07, 0x00},
};

PatchLine plFallAny[] = { 
	{0x8E7D, 0x32, 0x01},
};

PatchLine plNoAutoPause[] = {
	{ 0x8AC2, 0x28, 0x00}, 
	{ 0x8AC3, 0x0D, 0x00},
};

PatchLine plMono[] = {
	{ 0x8A0B, 0x3A, 0x3E}, 
	{ 0x8A0C, 0xCD, 0x47},
	{ 0x8A0D, 0x85, 0x18},
	{ 0x8A0E, 0xB7, 0x0B},
};

PatchLine plWibble[] = {
	{0x88a8,0x21,0xcd},
	{0x88a9,0xfb,0x2d},
	{0x88aa,0x85,0x97},
	{0x89f5,0x21,0xcd},
	{0x89f6,0x00,0x67},
	{0x89f7,0x60,0x97},
	{0x89f8,0x11,0x18},
	{0x89f9,0x00,0x06},
	{0x8a26,0x21,0xcd},
	{0x8a27,0x00,0x75},
	{0x8a28,0x5c,0x97},
	{0x8a29,0x11,0x18},
	{0x8a2a,0x00,0x06},
	{0x8c6e,0xcd,0xcd},
	{0x8c6f,0x56,0x18},
	{0x8c70,0x94,0x97},
	{0x8c80,0x11,0x11},
	{0x8c81,0x40,0xa3},
	{0x8c82,0x9c,0x97},
	{0x8c88,0x3a,0xcd},
	{0x8c89,0xe4,0x24},
	{0x8c8a,0x85,0x97},
	{0x8c8b,0x2f,0x00},
	{0x8cb3,0x32,0x32},
	{0x8cb4,0xcf,0x0f},
	{0x8cb5,0x59,0x58},
	{0x8cb6,0x32,0x32},
	{0x8cb7,0xd0,0x10},
	{0x8cb8,0x59,0x58},
	{0x8cb9,0x32,0x32},
	{0x8cba,0xef,0x2f},
	{0x8cbb,0x59,0x58},
	{0x8cbc,0x32,0x32},
	{0x8cbd,0xf0,0x30},
	{0x8cbe,0x59,0x58},
	{0x8cbf,0x3a,0x3a},
	{0x8cc0,0xe4,0xe4},
	{0x8cc1,0x85,0x85},
	{0x8cc2,0xc6,0xd6},
	{0x8cc3,0x04,0x04},
	{0x8cc4,0x32,0x32},
	{0x8cc5,0xe4,0xe4},
	{0x8cc6,0x85,0x85},
	{0x8cc7,0xfe,0xfe},
	{0x8cc8,0xc4,0x1c},
	{0x8cd1,0x11,0x11},
	{0x8cd2,0xca,0x4a},
	{0x8cd3,0x40,0x48},
	{0x8cdd,0x11,0x11},
	{0x8cde,0xd2,0x52},
	{0x8cdf,0x40,0x48},
	{0x8cef,0x32,0x32},
	{0x8cf0,0xca,0x4a},
	{0x8cf1,0x58,0x59},
	{0x8cf7,0x32,0x32},
	{0x8cf8,0xcb,0x4b},
	{0x8cf9,0x58,0x59},
	{0x8cff,0x32,0x32},
	{0x8d00,0xcc,0x4c},
	{0x8d01,0x58,0x59},
	{0x8d07,0x32,0x32},
	{0x8d08,0xcd,0x4d},
	{0x8d09,0x58,0x59},
	{0x8d0f,0x32,0x32},
	{0x8d10,0xd2,0x52},
	{0x8d11,0x58,0x59},
	{0x8d17,0x32,0x32},
	{0x8d18,0xd3,0x53},
	{0x8d19,0x58,0x59},
	{0x8d1f,0x32,0x32},
	{0x8d20,0xd4,0x54},
	{0x8d21,0x58,0x59},
	{0x8d27,0x32,0x32},
	{0x8d28,0xd5,0x55},
	{0x8d29,0x58,0x59},
	{0x9718,0x00,0xcd},
	{0x9719,0x00,0x56},
	{0x971a,0x00,0x94},
	{0x971b,0x00,0xcd},
	{0x971c,0x00,0x34},
	{0x971d,0x00,0x97},
	{0x971e,0x00,0x3e},
	{0x971f,0x00,0xe0},
	{0x9720,0x00,0x32},
	{0x9721,0x00,0xe4},
	{0x9722,0x00,0x85},
	{0x9723,0x00,0xc9},
	{0x9724,0x00,0x3a},
	{0x9725,0x00,0xe4},
	{0x9726,0x00,0x85},
	{0x9727,0x00,0x5f},
	{0x9728,0x00,0x3e},
	{0x9729,0x00,0xe0},
	{0x972a,0x00,0x93},
	{0x972b,0x00,0x2f},
	{0x972c,0x00,0xc9},
	{0x972d,0x00,0xcd},
	{0x972e,0x00,0x34},
	{0x972f,0x00,0x97},
	{0x9730,0x00,0x21},
	{0x9731,0x00,0xfb},
	{0x9732,0x00,0x85},
	{0x9733,0x00,0xc9},
	{0x9734,0x00,0x21},
	{0x9735,0x00,0xe0},
	{0x9736,0x00,0x4f},
	{0x9737,0x00,0x11},
	{0x9739,0x00,0x40},
	{0x973a,0x00,0x06},
	{0x973b,0x00,0x40},
	{0x973c,0x00,0xcd},
	{0x973d,0x00,0x8f},
	{0x973e,0x00,0x97},
	{0x973f,0x00,0x10},
	{0x9740,0x00,0xfb},
	{0x9741,0x00,0x21},
	{0x9742,0x00,0xe0},
	{0x9743,0x00,0x59},
	{0x9744,0x00,0x11},
	{0x9746,0x00,0x58},
	{0x9747,0x00,0x06},
	{0x9748,0x00,0x08},
	{0x9749,0x00,0xcd},
	{0x974a,0x00,0x8f},
	{0x974b,0x00,0x97},
	{0x974c,0x00,0x10},
	{0x974d,0x00,0xfb},
	{0x974e,0x00,0xc9},
	{0x974f,0x00,0x11},
	{0x9751,0x00,0x60},
	{0x9752,0x00,0x01},
	{0x9754,0x00,0x10},
	{0x9755,0x00,0xed},
	{0x9756,0x00,0xb0},
	{0x9757,0x00,0xcd},
	{0x9758,0x00,0x67},
	{0x9759,0x00,0x97},
	{0x975a,0x00,0x21},
	{0x975c,0x00,0x58},
	{0x975d,0x00,0x11},
	{0x975f,0x00,0x5c},
	{0x9760,0x00,0x01},
	{0x9762,0x00,0x02},
	{0x9763,0x00,0xed},
	{0x9764,0x00,0xb0},
	{0x9765,0x00,0x18},
	{0x9766,0x00,0x0e},
	{0x9767,0x00,0x21},
	{0x9768,0x00,0xe0},
	{0x9769,0x00,0x6f},
	{0x976a,0x00,0x11},
	{0x976c,0x00,0x40},
	{0x976d,0x00,0x06},
	{0x976e,0x00,0x80},
	{0x976f,0x00,0xcd},
	{0x9770,0x00,0x83},
	{0x9771,0x00,0x97},
	{0x9772,0x00,0x10},
	{0x9773,0x00,0xfb},
	{0x9774,0x00,0xc9},
	{0x9775,0x00,0x21},
	{0x9776,0x00,0xe0},
	{0x9777,0x00,0x5d},
	{0x9778,0x00,0x11},
	{0x977a,0x00,0x58},
	{0x977b,0x00,0x06},
	{0x977c,0x00,0x10},
	{0x977d,0x00,0xcd},
	{0x977e,0x00,0x83},
	{0x977f,0x00,0x97},
	{0x9780,0x00,0x10},
	{0x9781,0x00,0xfb},
	{0x9782,0x00,0xc9},
	{0x9783,0x00,0xc5},
	{0x9784,0x00,0x01},
	{0x9785,0x00,0x20},
	{0x9787,0x00,0xed},
	{0x9788,0x00,0xb0},
	{0x9789,0x00,0x01},
	{0x978a,0x00,0xc0},
	{0x978b,0x00,0xff},
	{0x978c,0x00,0x09},
	{0x978d,0x00,0xc1},
	{0x978e,0x00,0xc9},
	{0x978f,0x00,0xc5},
	{0x9790,0x00,0x01},
	{0x9791,0x00,0x20},
	{0x9793,0x00,0x1a},
	{0x9794,0x00,0xed},
	{0x9795,0x00,0xa0},
	{0x9796,0x00,0x2b},
	{0x9797,0x00,0x77},
	{0x9798,0x00,0x23},
	{0x9799,0x00,0x79},
	{0x979a,0x00,0xb7},
	{0x979b,0x00,0x20},
	{0x979c,0x00,0xf6},
	{0x979d,0x00,0x01},
	{0x979e,0x00,0xc0},
	{0x979f,0x00,0xff},
	{0x97a0,0x00,0x09},
	{0x97a1,0x00,0xc1},
	{0x97a2,0x00,0xc9},
	{0x97a3,0x00,0x3d},
	{0x97a4,0x00,0x76},
	{0x97a5,0x00,0x43},
	{0x97a6,0x00,0x8d},
	{0x97a7,0x00,0x80},
	{0x97a8,0x00,0x02},
	{0x97a9,0x00,0x80},
	{0x97aa,0x00,0x01},
	{0x97ab,0x00,0x84},
	{0x97ac,0x00,0x09},
	{0x97ad,0x00,0x88},
	{0x97ae,0x00,0x35},
	{0x97af,0x00,0x48},
	{0x97b0,0x00,0x42},
	{0x97b1,0x00,0x20},
	{0x97b2,0x00,0x80},
	{0x97b3,0x00,0x20},
	{0x97b4,0x00,0x80},
	{0x97b5,0x00,0x10},
	{0x97b6,0x00,0x80},
	{0x97b7,0x00,0x10},
	{0x97b8,0x00,0x80},
	{0x97b9,0x00,0x10},
	{0x97ba,0x00,0x80},
	{0x97bb,0x00,0x10},
	{0x97bc,0x00,0x80},
	{0x97bd,0x00,0x10},
	{0x97be,0x00,0x80},
	{0x97bf,0x00,0x10},
	{0x97c0,0x00,0x80},
	{0x97c1,0x00,0x10},
	{0x97c2,0x00,0x80},
};


PatchLine plWobble[] = 
{
	{0x944f,0x9b,0xc3},
	{0x9450,0x96,0x97},
	{0x97c3,0x00,0x3a},
	{0x97c4,0x00,0xcb},
	{0x97c5,0x00,0x85},
	{0x97c6,0x00,0xe6},
	{0x97c7,0x00,0x01},
	{0x97c8,0x00,0xca},
	{0x97c9,0x00,0x9b},
	{0x97ca,0x00,0x96},
	{0x97cb,0x00,0x7b},
	{0x97cc,0x00,0xe6},
	{0x97cd,0x00,0x1f},
	{0x97ce,0x00,0xfe},
	{0x97cf,0x00,0x1f},
	{0x97d0,0x00,0x28},
	{0x97d1,0x00,0x14},
	{0x97d2,0x00,0x7e},
	{0x97d3,0x00,0x0e},
	{0x97d5,0x00,0xcb},
	{0x97d6,0x00,0x3f},
	{0x97d7,0x00,0xcb},
	{0x97d8,0x00,0x19},
	{0x97d9,0x00,0x12},
	{0x97da,0x00,0x1c},
	{0x97db,0x00,0x1a},
	{0x97dc,0x00,0xe6},
	{0x97dd,0x00,0x7f},
	{0x97de,0x00,0xb1},
	{0x97df,0x00,0x12},
	{0x97e0,0x00,0x1d},
	{0x97e1,0x00,0x14},
	{0x97e2,0x00,0x23},
	{0x97e3,0x00,0x10},
	{0x97e4,0x00,0xed},
	{0x97e5,0x00,0xc9},
	{0x97e6,0x00,0x7e},
	{0x97e7,0x00,0xcb},
	{0x97e8,0x00,0x3f},
	{0x97e9,0x00,0x12},
	{0x97ea,0x00,0x14},
	{0x97eb,0x00,0x23},
	{0x97ec,0x00,0x10},
	{0x97ed,0x00,0xf8},
	{0x97ee,0x00,0xc9},
};

PatchLine plJiggle[] = 
{
	{0x944f,0x9b,0xc3},
	{0x9450,0x96,0x97},
	{0x97c3,0x00,0x3a},
	{0x97c4,0x00,0xcb},
	{0x97c5,0x00,0x85},
	{0x97c6,0x00,0xe6},
	{0x97c7,0x00,0x01},
	{0x97c8,0x00,0xca},
	{0x97c9,0x00,0x9b},
	{0x97ca,0x00,0x96},
	{0x97cb,0x00,0xd5},
	{0x97cc,0x00,0x7b},
	{0x97cd,0x00,0xe6},
	{0x97ce,0x00,0xe0},
	{0x97cf,0x00,0x28},
	{0x97d0,0x00,0x0a},
	{0x97d1,0x00,0x7b},
	{0x97d2,0x00,0xd6},
	{0x97d3,0x00,0x20},
	{0x97d4,0x00,0x5f},
	{0x97d5,0x00,0x7a},
	{0x97d6,0x00,0xc6},
	{0x97d7,0x00,0x07},
	{0x97d8,0x00,0x57},
	{0x97d9,0x00,0x18},
	{0x97da,0x00,0x05},
	{0x97db,0x00,0x15},
	{0x97dc,0x00,0x7b},
	{0x97dd,0x00,0xf6},
	{0x97de,0x00,0xe0},
	{0x97df,0x00,0x5f},
	{0x97e0,0x00,0x7e},
	{0x97e1,0x00,0x12},
	{0x97e2,0x00,0xd1},
	{0x97e3,0x00,0x23},
	{0x97e4,0x00,0x05},
	{0x97e5,0x00,0xc3},
	{0x97e6,0x00,0x9b},
	{0x97e7,0x00,0x96}
};


PatchLine plFastFix[] =
{
	{0x931c,0x26,0x26},
	{0x931d,0x83,0x9f},
	{0x9f20,0x00,0x01},
	{0x9f21,0x00,0x01},
	{0x9f22,0x00,0x01},
	{0x9f23,0x00,0x01},
	{0x9f24,0x00,0x01},
	{0x9f25,0x00,0x01},
	{0x9f26,0x00,0x01},
	{0x9f27,0x00,0x01},
	{0x9f28,0x00,0x01},
	{0x9f29,0x00,0x01},
	{0x9f2a,0x00,0x01},
	{0x9f2b,0x00,0x01},
	{0x9f2c,0x00,0x02},
	{0x9f2d,0x00,0x02},
	{0x9f2e,0x00,0x02},
	{0x9f2f,0x00,0x02},
	{0x9f30,0x00,0x02},
	{0x9f31,0x00,0x02},
	{0x9f32,0x00,0x02},
	{0x9f33,0x00,0x02},
	{0x9f34,0x00,0x02},
	{0x9f35,0x00,0x02},
	{0x9f36,0x00,0x02},
	{0x9f37,0x00,0x02},
	{0x9f38,0x00,0x02},
	{0x9f39,0x00,0x02},
	{0x9f3a,0x00,0x02},
	{0x9f3b,0x00,0x02},
	{0x9f3c,0x00,0x02},
	{0x9f3d,0x00,0x02},
	{0x9f3e,0x00,0x02},
	{0x9f3f,0x00,0x02},
	{0x9f40,0x00,0x02},
	{0x9f41,0x00,0x02},
	{0x9f42,0x00,0x01},
	{0x9f43,0x00,0x02},
	{0x9f44,0x00,0x02},
	{0x9f45,0x00,0x01},
	{0x9f46,0x00,0x01},
	{0x9f47,0x00,0x02},
	{0x9f48,0x00,0x01},
	{0x9f49,0x00,0x01},
	{0x9f4a,0x00,0x02},
	{0x9f4b,0x00,0x02},
	{0x9f4c,0x00,0x03},
	{0x9f4d,0x00,0x02},
	{0x9f4e,0x00,0x03},
	{0x9f4f,0x00,0x02},
	{0x9f50,0x00,0x03},
	{0x9f51,0x00,0x03},
	{0x9f52,0x00,0x03},
	{0x9f53,0x00,0x03},
	{0x9f54,0x00,0x03},
	{0x9f55,0x00,0x03},
	{0x9f80,0x00,0x06},
	{0x9f81,0x00,0x06},
	{0x9f82,0x00,0x06},
	{0x9f83,0x00,0x06},
	{0x9f84,0x00,0x06},
	{0x9f85,0x00,0x06},
	{0x9f86,0x00,0x06},
	{0x9f87,0x00,0x06},
	{0x9f88,0x00,0x06},
	{0x9f89,0x00,0x06},
	{0x9f8a,0x00,0x06},
	{0x9f8b,0x00,0x06},
	{0x9f8c,0x00,0x06},
	{0x9f8d,0x00,0x06},
	{0x9f8e,0x00,0x06},
	{0x9f8f,0x00,0x06},
	{0x9f90,0x00,0x06},
	{0x9f91,0x00,0x06},
	{0x9f92,0x00,0x06},
	{0x9f93,0x00,0x06},
	{0x9f94,0x00,0x06},
	{0x9f95,0x00,0x06},
	{0x9f96,0x00,0x06},
	{0x9f97,0x00,0x06},
	{0x9f98,0x00,0x06},
	{0x9f99,0x00,0x06},
	{0x9f9a,0x00,0x06},
	{0x9f9b,0x00,0x06},
	{0x9f9c,0x00,0x06},
	{0x9f9d,0x00,0x06},
	{0x9f9e,0x00,0x06},
	{0x9f9f,0x00,0x06},
	{0x9fa0,0x00,0x06},
	{0x9fa1,0x00,0x06},
	{0x9fa2,0x00,0x06},
	{0x9fa3,0x00,0x06},
	{0x9fa4,0x00,0x06},
	{0x9fa5,0x00,0x06},
	{0x9fa6,0x00,0x06},
	{0x9fa7,0x00,0x06},
	{0x9fa8,0x00,0x06},
	{0x9fa9,0x00,0x06},
	{0x9faa,0x00,0x06},
	{0x9fab,0x00,0x06},
	{0x9fac,0x00,0x06},
	{0x9fad,0x00,0x06},
	{0x9fae,0x00,0x06},
	{0x9faf,0x00,0x06},
	{0x9fb0,0x00,0x04},
	{0x9fb1,0x00,0x06},
	{0x9fb2,0x00,0x06},
	{0x9fb3,0x00,0x04},
	{0x9fb4,0x00,0x06},
	{0x9fb5,0x00,0x04},
	{0x9fb6,0x00,0x06},
	{0x9fb7,0x00,0x04},
	{0x9fb8,0x00,0x06},
	{0x9fb9,0x00,0x04},
	{0x9fba,0x00,0x04},
	{0x9fbb,0x00,0x04},
	{0x9fbc,0x00,0x06},
	{0x9fbd,0x00,0x04},
	{0x9fbe,0x00,0x04},
	{0x9fbf,0x00,0x04},
	{0x9fc0,0x00,0x04},
	{0x9fc1,0x00,0x04},
	{0x9fc2,0x00,0x04},
	{0x9fc3,0x00,0x04},
	{0x9fc4,0x00,0x04},
	{0x9fc5,0x00,0x04},
	{0x9fc6,0x00,0x04},
	{0x9fc7,0x00,0x04},
	{0x9fc8,0x00,0x04},
	{0x9fc9,0x00,0x04},
	{0x9fca,0x00,0x04},
	{0x9fcb,0x00,0x04},
	{0x9fcc,0x00,0x04},
	{0x9fcd,0x00,0x04},
	{0x9fce,0x00,0x04},
	{0x9fcf,0x00,0x04},
	{0x9fd0,0x00,0x04},
	{0x9fd1,0x00,0x04},
	{0x9fd2,0x00,0x04},
	{0x9fd3,0x00,0x04},
	{0x9fd4,0x00,0x04},
	{0x9fd5,0x00,0x04},
};



PatchLine plSoftricksDeath[] = {
	{ 0x8C02, 0x47, 0xC9}, { 0x8C03, 0x21, 0x32}, { 0x8C04, 0x00, 0x95}, 
	{ 0x8C05, 0x58, 0x88}, { 0x8C06, 0x11, 0xCD}, { 0x8C07, 0x01, 0x13}, 
	{ 0x8C08, 0x58, 0x88}, { 0x8C09, 0x01, 0x3E}, { 0x8C0A, 0xFF, 0x01}, 
	{ 0x8C0B, 0x01, 0x32}, { 0x8C0C, 0x77, 0x95}, { 0x8C0D, 0xED, 0x88}, 
	{ 0x8C0E, 0xB0, 0x06}, { 0x8C0F, 0x5F, 0x32}, { 0x8C10, 0x2F, 0xC5}, 
	{ 0x8C11, 0xE6, 0x78}, { 0x8C12, 0x07, 0xCD}, { 0x8C13, 0x07, 0xDE}, 
	{ 0x8C14, 0x07, 0x96}, { 0x8C15, 0x07, 0xC1}, { 0x8C16, 0xF6, 0x10}, 
	{ 0x8C17, 0x07, 0xF8}, { 0x8C18, 0x57, 0xC3}, { 0x8C19, 0x4B, 0x33}, 
	{ 0x8C1A, 0xCB, 0x8C}, { 0x8C1B, 0x09, 0x00}, { 0x8C1C, 0xCB, 0x00}, 
	{ 0x8C1D, 0x09, 0x00}, { 0x8C1E, 0xCB, 0x00}, { 0x8C1F, 0x09, 0x00}, 
	{ 0x8C20, 0xF6, 0x00}, { 0x8C21, 0x10, 0x00}, { 0x8C22, 0xAF, 0x00}, 
	{ 0x8C23, 0xD3, 0x00}, { 0x8C24, 0xFE, 0x00}, { 0x8C25, 0xEE, 0x00},
	{ 0x8C26, 0x18, 0x00}, { 0x8C27, 0x42, 0x00},	// 0x26 lines
};

PatchLine plSoftricksAttract[] = {
	{ 0x88F3, 0xE0, 0xFF}, { 0x88FA, 0x13, 0x9B}, { 0x88FB, 0x88, 0x97},
	{ 0x979B, 0x00, 0x21}, { 0x979E, 0x00, 0x22}, {0x979F, 0x00, 0x1C},
	{ 0x97A0, 0x00, 0x8B}, { 0x97A1, 0x00, 0x22}, {0x97A2, 0x00, 0x1D},
	{ 0x97A3, 0x00, 0x8B}, { 0x97A4, 0x00, 0xAF}, {0x97A5, 0x00, 0x32},
	{ 0x97A6, 0x00, 0x20}, { 0x97A7, 0x00, 0x84}, {0x97A8, 0x00, 0x32}, 
	{ 0x97A9, 0x00, 0xFF}, { 0x97AA, 0x00, 0x97}, {0x97AB, 0x00, 0x3E}, 
	{ 0x97AC, 0x00, 0xC9}, { 0x97AD, 0x00, 0x32}, {0x97AE, 0x00, 0x70},
	{ 0x97AF, 0x00, 0x8B}, { 0x97B0, 0x00, 0xCD}, {0x97B1, 0x00, 0xFC},
	{ 0x97B2, 0x00, 0x88}, { 0x97B3, 0x00, 0x06}, {0x97B4, 0x00, 0x3F},
	{ 0x97B5, 0x00, 0xC5}, { 0x97B6, 0x00, 0xCD}, {0x97B7, 0x00, 0xAD},
	{ 0x97B8, 0x00, 0x89}, { 0x97B9, 0x00, 0x01}, {0x97BA, 0x00, 0xFE},

	{ 0x97BB, 0x00, 0xBF}, { 0x97BC, 0x00, 0xED}, {0x97BD, 0x00, 0x78},
	{ 0x97BE, 0x00, 0xCB}, { 0x97BF, 0x00, 0x47}, {0x97C0, 0x00, 0x28},
	{ 0x97C1, 0x00, 0x13}, { 0x97C2, 0x00, 0xC1}, {0x97C3, 0x00, 0x10},
	{ 0x97C4, 0x00, 0xF0}, { 0x97C5, 0x00, 0x3A}, {0x97C6, 0x00, 0xFF}, 
	{ 0x97C7, 0x00, 0x97}, { 0x97C8, 0x00, 0x3C}, {0x97C9, 0x00, 0x32}, 
	{ 0x97CA, 0x00, 0xFF}, { 0x97CB, 0x00, 0x97}, {0x97CC, 0x00, 0x32},
	{ 0x97CD, 0x00, 0x20}, { 0x97CE, 0x00, 0x84}, {0x97CF, 0x00, 0xFE},
	{ 0x97D0, 0x00, 0x3E}, { 0x97D1, 0x00, 0x20}, {0x97D2, 0x00, 0xDD},
	{ 0x97D3, 0x00, 0x18}, { 0x97D4, 0x00, 0x01}, {0x97D5, 0x00, 0xF1},
	{ 0x97D6, 0x00, 0x3E}, { 0x97D7, 0x00, 0x01}, {0x97D8, 0x00, 0x32},
	{ 0x97D9, 0x00, 0x70}, { 0x97DA, 0x00, 0x8B},

	{ 0x97DB, 0x00, 0x3E}, { 0x97DC, 0x00, 0xCA}, {0x97DD, 0x00, 0x32},
	{ 0x97DE, 0x00, 0x1C}, { 0x97DF, 0x00, 0x8B}, {0x97E0, 0x00, 0x21},
	{ 0x97E1, 0x00, 0x01}, { 0x97E2, 0x00, 0x8C}, {0x97E3, 0x00, 0x22},
	{ 0x97E4, 0x00, 0x1D}, { 0x97E5, 0x00, 0x8B}, {0x97E6, 0x00, 0xC3},
	{ 0x97E7, 0x00, 0xCA}, { 0x97E8, 0x00, 0x87}, 
	// Should be 0x4E lines minus 2 zero lines
	// plus 2 lines for jump to attract mode
	// plus 1 line for long scrolly
};

PatchLine plDeathless[] = {
/* The first segment is for 'start in same room' -- a necessary precondition
 * of 'avoid infy death'. */
		{0x87E5, 0x3E, 0x3A}, /* 1 */
		{0x87E6, 0xD0, 0xED},
		{0x87E7, 0x32, 0x80},
		{0x87E8, 0xCF, 0x32},
		{0x87E9, 0x85, 0xCF}, /* 5 */
		{0x87EA, 0x3E, 0x85},
		{0x87EB, 0x21, 0x2A},
		{0x87EC, 0x32, 0xEE},
		{0x87ED, 0x20, 0x80},
		{0x87EE, 0x84, 0x22}, /* 10 */
		{0x87EF, 0x21, 0xD3},
		{0x87F0, 0xB4, 0x85},
		{0x87F1, 0x5D, 0x00},
		{0x87F2, 0x22, 0x00},
		{0x87F3, 0xD3, 0x00}, /* 15 */
		{0x87F4, 0x85, 0x00},
/* Now the 'avoid' patch proper */
		{0x8C01, 0x3E, 0x3A},
		{0x8C02, 0x47, 0xED},
		{0x8C03, 0x21, 0x80},
		{0x8C04, 0x00, 0x32}, /* 20 */
		{0x8C05, 0x58, 0xCF},
		{0x8C06, 0x11, 0x85},
		{0x8C07, 0x01, 0x3E},
		{0x8C08, 0x58, 0x47},
		{0x8C09, 0x01, 0x2A}, /* 25 */
		{0x8C0A, 0xFF, 0xEE},
		{0x8C0B, 0x01, 0x80},
		{0x8C0C, 0x77, 0x22},
		{0x8C0D, 0xED, 0xD3},
		{0x8C0E, 0xB0, 0x85}, /* 30 */
		{0x8C3D, 0xD7, 0xD1},
		{0x8C3F, 0x11, 0x36},
		{0x8C40, 0xCF, 0x00},
		{0x8C41, 0x85, 0x00},
		{0x8C42, 0x01, 0x00}, /* 35 */
		{0x8C43, 0x07, 0x00},
		{0x8C44, 0x00, 0x00},
		{0x8C45, 0xED, 0x00},
		{0x8C46, 0xB0, 0x00},
};

// XXX These are not implemented yet
PatchLine plPauseBugfix1[] =
{
	{ 0x8B03, 0x5B, 0x5A },
	{ 0x8B10, 0xED, 0x0E },
	{ 0x8B11, 0xB0, 0xFE },
};

PatchLine plPauseBugfix2[] =
{
	{ 0x8B1A, 0xFE, 0x3C },
	{ 0x8B1B, 0xFF, 0xCA },
	{ 0x8B1C, 0xCA, 0x01 },
	{ 0x8B1D, 0x01, 0x8C },
	{ 0x8B1E, 0x8C, 0x01 },
	{ 0x8B1F, 0x06, 0xFE },
	{ 0x8B20, 0xBF, 0xBF },
};

/* There is a case that the 'bad' pause bug fix should be converted to one of 
 * the others the moment the game is loaded. */
PatchLine plPauseBugfixBad[] =
{
	{ 0x8B07, 0x21, 0xC3 },
	{ 0x8B08, 0x00, 0xF0 },
	{ 0x8B09, 0x9A, 0xFF },
};


#define DECLARE_PATCH(patchname, patchlines) \
Patch patchname = { NULL, NULL, sizeof(patchlines) / sizeof(patchlines[0]), \
			patchlines }

DECLARE_PATCH(patchIX6old           , plIX6old );
DECLARE_PATCH(patchIX6new           , plIX6new );
DECLARE_PATCH(patchBlackWilly       , plBlackWilly );
DECLARE_PATCH(patchFallAny          , plFallAny );
DECLARE_PATCH(patchNoAutoPause      , plNoAutoPause );
DECLARE_PATCH(patchSoftricksDeath   , plSoftricksDeath );
DECLARE_PATCH(patchSoftricksAttract , plSoftricksAttract );
DECLARE_PATCH(patchDeathless        , plDeathless );
DECLARE_PATCH(patchMonochrome       , plMono );
DECLARE_PATCH(patchWibble           , plWibble );
DECLARE_PATCH(patchWobble           , plWobble );
DECLARE_PATCH(patchJiggle           , plJiggle );
DECLARE_PATCH(patchFastFix          , plFastFix );

JswPatchPage::JswPatchPage(JswGame *g)
{
	int x, y;
	m_game = g;

	x = 9 * CHAR_W;
	y = CHAR_H;

	m_fflabel = new VideoLabel(x, y, "File format:");

	m_fflist = new FileTypeList((jswByte *)&m_game->getMem()->m_type, 
				x + 13 * CHAR_W, y, 8 * CHAR_W, 6*CHAR_H);
	m_fflist->setTitle("");
	m_fflist->requireClick(1);

	setTitle("Game");
	addChild(m_fflabel);
	addChild(m_fflist);
	setFocus(m_fflist);

	y += 6 * CHAR_H + 2;

	m_patchData = new Patch[20];
	m_patchCount = 0;
	m_patchMax = 20;

	/* Add the patches */
#define ADD_PATCH(p, l) \
	p.label    = new VideoLabel(x, y, l); \
	p.checkbox = new VideoCheckbox(x + 21 * CHAR_W, y); \
	addPatch(&p); \
	y += CHAR_H + 4;

	ADD_PATCH(patchIX6new,		"Adjacent ropes patch   (new)");
	ADD_PATCH(patchIX6old,		"Adjacent ropes patch   (old)");
	ADD_PATCH(patchBlackWilly,	"Black Willy");
        ADD_PATCH(patchFallAny,		"Fall any height");
	ADD_PATCH(patchNoAutoPause,	"No auto pause");
	ADD_PATCH(patchMonochrome,	"Monochrome");
	ADD_PATCH(patchWibble,		"Jet Set Wibble");
	ADD_PATCH(patchWobble,		"Items wobble");
	ADD_PATCH(patchJiggle,		"Items jiggle");
	ADD_PATCH(patchFastFix,		"Fix bug in 'fast JSW'");
	ADD_PATCH(patchSoftricksDeath,	"Softricks death");
	ADD_PATCH(patchSoftricksAttract,"Attract mode");

	updatePatches();

}

JswPatchPage::~JswPatchPage()
{	
	int n;
	delete m_fflabel;
	delete m_fflist;

	for (n = 0; n < m_patchCount; n++)	
	{
		delete m_patchData[n].label;
		delete m_patchData[n].checkbox;
	}	
	delete [] m_patchData;
}


void JswPatchPage::updatePatches(void)
{
	int check;
	int n, m, value;
	SpectrumMemory *mem = m_game->getMem();
	
	for (n = 0; n < m_patchCount; n++)
	{
		check = -1;
//		printf("%s (%d)\n", m_patchData[n].label->getText(),
//				m_patchData[n].lineCount);
		for (m = 0; m < m_patchData[n].lineCount; m++)
                {

                	value = mem->peek(m_patchData[n].lines[m].address);

			if (value == m_patchData[n].lines[m].oldVal &&
			    (check == -1 || check == 0)) check = 0;
			else if (value == m_patchData[n].lines[m].newVal && 
                            (check == -1 || check == 1)) check = 1;
			else check = 2;
// for debugging	
//			 printf("%04x: %02x %02x %02x %d\n", 
//				m_patchData[n].lines[m].address, 
//				m_patchData[n].lines[m].oldVal, 
//				m_patchData[n].lines[m].newVal, 
//				value, check);
		}
		if (check == -1) check = 0;
		if (check == 2) m_patchData[n].checkbox->setStates(3);
		else		m_patchData[n].checkbox->setStates(2);
		m_patchData[n].checkbox->setCheck(check);
		m_patchData[n].checkbox->setListener(this);	
	}
}


void JswPatchPage::addPatch(Patch *p)
{
	if (m_patchCount == m_patchMax)
	{
		Patch *q = new Patch[2 * m_patchMax];
		memcpy(q, m_patchData, m_patchMax * sizeof(Patch));
		delete m_patchData;
		m_patchData = q;
		m_patchMax *= 2;
	}
	memcpy(&m_patchData[m_patchCount], p, sizeof(Patch));
	++m_patchCount;
	addChild(p->label);
	addChild(p->checkbox);
}


void JswPatchPage::removePatch(int id)
{
	int n;
	removeChild(m_patchData[id].label);
	removeChild(m_patchData[id].checkbox);
	for (n = id; n < (m_patchCount - 1); n++)
	{
		m_patchData[n] = m_patchData[n+1];
	}
	--m_patchCount;
}



int JswPatchPage::redraw(int whichRectangle)
{

	int rv = VideoNotePage::redraw(whichRectangle);

	videoScreen->bottomBar("Game properties");
	return rv;
}



int JswPatchPage::onCheckboxSelect(VideoCheckbox *b, int value)
{
	int n, m;
	jswByte from, to;
	int addr;
	SpectrumMemory *mem = m_game->getMem();

	if (value == 2) return ZXE_CANCEL;
	if (b->getCheck() == 2) return ZXE_CANCEL;	

	for (n = 0; n < m_patchCount; n++)
	{
		if (m_patchData[n].checkbox == b)
		{
			for (m = 0; m < m_patchData[n].lineCount; m++)
			{
				addr = m_patchData[n].lines[m].address;
				if (value)
				{ 
					from = m_patchData[n].lines[m].oldVal;
					to   = m_patchData[n].lines[m].newVal;
				}
				else
				{
                                        to   = m_patchData[n].lines[m].oldVal;
                                        from = m_patchData[n].lines[m].newVal;
				}
				if (mem->peek(addr) == from) mem->poke(addr,to);
			}
			updatePatches();
			return ZXE_OK;
		}
	}
	return ZXE_CANCEL;
}


int JswPatchPage::preContextMenu(void)
{
	VideoMenu vm("Game options", "Cancel", "Clear rooms", 
			"Clear guardians", "Clear sprites", "Exit", NULL);
	int rv = vm.doModal();

	if (rv >= ZXE_QUIT) return rv;
	if (rv != ZXE_OK) return ZXE_CONTINUE;
	switch(vm.getSelected())
	{
		case 0: return ZXE_CONTINUE;
		case 1: return m_game->clearRooms();
		case 2: return m_game->clearGuardians();
		case 3: return m_game->clearSprites();
		case 4: return ZXE_OK;
	}
	return ZXE_CONTINUE;
}

